package edu.certification.abhijitsarkar.ocewsd.jaxws.pojo.endpoint;

import javax.annotation.Resource;
import javax.jws.HandlerChain;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.xml.ws.WebServiceContext;
import javax.xml.ws.WebServiceException;

import org.jboss.security.annotation.SecurityDomain;
import org.jboss.ws.api.annotation.AuthMethod;
import org.jboss.ws.api.annotation.TransportGuarantee;
import org.jboss.ws.api.annotation.WebContext;

import edu.certification.abhijitsarkar.ocewsd.jaxws.utility.Time;

@WebService(name = "Time", serviceName = "TimeService", portName = "TimeServicePort", targetNamespace = "http://abhijitsarkar.certification.edu/ocewsd/jaxws/pojo/endpoint", endpointInterface = "edu.certification.abhijitsarkar.ocewsd.jaxws.pojo.endpoint.TimeServiceSEI")
@HandlerChain(file = "handler-chain.xml")
// should be configurable in jboss-web.xml,
// https://issues.jboss.org/browse/JBWS-3487
//@SecurityDomain(value = "other")
//@WebContext(contextRoot = "/jaxws-pojo-endpoint", authMethod = AuthMethod.BASIC, secureWSDLAccess = false, transportGuarantee = TransportGuarantee.NONE, urlPattern = "/TimeService")
public class TimeService implements TimeServiceSEI {

	@WebMethod
	@Override
	public Time getCurrentTime() {
		return new Time();
	}

	/* HttpBasicAuthenticationHandler authenticates this request */
	@WebMethod
	@Override
	public Time getCurrentTimeAfterHttpBasicAuthentication() {
		return getCurrentTime();
	}

	@WebMethod
	@Override
	public Time getCurrentTimeAfterDeclarativeRoleBasedAuthorization() {
		return getCurrentTime();
	}

	@WebMethod
	@Override
	public Time getCurrentTimeAfterProgrammaticRoleBasedAuthorization() {
		programmaticRoleBasedAuthorization();
		return getCurrentTime();
	}

	@WebMethod
	@Override
	public Time getCurrentTimeAfterUserPrincipalAuthentication() {
		userPrincipalAuthentication();
		return getCurrentTime();
	}

	/* ProgrammaticAuthenticationHandler authenticates this request */
	@WebMethod
	@Override
	public Time getCurrentTimeAfterProgrammaticAuthentication() {
		return getCurrentTime();
	}

	private void userPrincipalAuthentication() {
		if (!("user".equals(context.getUserPrincipal()))) {
			throw new WebServiceException("Principal "
					+ context.getUserPrincipal()
					+ " is not authorized to invoke this method");
		}
	}

	private void programmaticRoleBasedAuthorization() {
		if (!(context.isUserInRole("AppUser"))) {
			throw new WebServiceException("Principal "
					+ context.getUserPrincipal()
					+ " is not authorized to invoke this method");
		}
	}

	@Resource
	private WebServiceContext context;
}
